package alarmtest.android.ruz76.gis.vsb.cz.alarmtest8;

import android.app.Notification;
import android.app.NotificationChannel;
import android.app.NotificationManager;
import android.content.BroadcastReceiver;
import android.content.ContentValues;
import android.content.Context;
import android.content.Intent;
import android.database.sqlite.SQLiteDatabase;
import android.os.Build;
import android.util.Log;

import java.text.SimpleDateFormat;
import java.util.Date;

public class AlarmReceiver extends BroadcastReceiver {

    @Override
    public void onReceive(Context context, Intent intent) {
        Log.d("Testing", "onReceive");
        DatesTableDbHelper dbHelper = new DatesTableDbHelper(context);
        // Gets the data repository in write mode
        SQLiteDatabase db = dbHelper.getWritableDatabase();

        // Create a new map of values, where column names are the keys
        ContentValues values = new ContentValues();
        Date now = new Date();
        SimpleDateFormat simpleFormat = new SimpleDateFormat("H:m:s");
        String nowString = simpleFormat.format(now);
        values.put(DatesTable.DatesEntry.COLUMN_NAME_LOGDATETIME, nowString);

        // Insert the new row, returning the primary key value of the new row
        long newRowId = db.insert(DatesTable.DatesEntry.TABLE_NAME, null, values);

        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.O) {
            context.startForegroundService(new Intent(context, ServiceClass.class));
        } else {
            context.startService(new Intent(context, ServiceClass.class));
        }
    }
}
