package alarmtest.android.ruz76.gis.vsb.cz.alarmtest8;

import android.app.Notification;
import android.app.NotificationChannel;
import android.app.NotificationManager;
import android.app.Service;
import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.os.Build;
import android.os.IBinder;
import android.preference.PreferenceManager;
import android.provider.BaseColumns;
import android.util.Log;
import android.widget.Toast;

import java.util.ArrayList;
import java.util.List;

public class ServiceClass extends Service implements GetRequestUpdate {



    @Override
    public void onCreate() {
        // TODO Auto-generated method stub
        super.onCreate();

        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.O) {
            NotificationManager notificationManager = (NotificationManager) getSystemService(Context.NOTIFICATION_SERVICE);
            String channelId = getString(R.string.app_name);
            NotificationChannel notificationChannel = new NotificationChannel(channelId, channelId, NotificationManager.IMPORTANCE_DEFAULT);
            notificationChannel.setDescription(channelId);
            notificationChannel.setSound(null, null);

            notificationManager.createNotificationChannel(notificationChannel);
            Notification notification = new Notification.Builder(this, channelId)
                    .setContentTitle(getString(R.string.app_name))
                    .setContentText("X")
                    .setSmallIcon(R.drawable.ic_launcher_background)
                    .build();
            startForeground(1, notification);
        }

        Log.d("Testing", "Service got created");
        //Toast.makeText(this, "ServiceClass.onCreate()", Toast.LENGTH_LONG).show();

        Context context = this;
        DatesTableDbHelper dbHelper = new DatesTableDbHelper(context);
        SQLiteDatabase db = dbHelper.getReadableDatabase();

        // Define a projection that specifies which columns from the database
        // you will actually use after this query.
        String[] projection = {
                BaseColumns._ID,
                DatesTable.DatesEntry.COLUMN_NAME_LOGDATETIME
        };

        SharedPreferences sharedPrefs = PreferenceManager.getDefaultSharedPreferences(context);
        long lastId = sharedPrefs.getLong("lastid", 0);

        String selection = DatesTable.DatesEntry._ID + " > ?";
        String[] selectionArgs = { String.valueOf(lastId) };

        Cursor cursor = db.query(
                DatesTable.DatesEntry.TABLE_NAME,   // The table to query
                projection,             // The array of columns to return (pass null to get all)
                selection,              // The columns for the WHERE clause
                selectionArgs,          // The values for the WHERE clause
                null,                   // don't group the rows
                null,                   // don't filter by row groups
                null               // The sort order
        );

        List itemIds = new ArrayList<>();
        StringBuilder sb = new StringBuilder();
        long lastIdSended = 0;
        while(cursor.moveToNext()) {
            long itemId = cursor.getLong(cursor.getColumnIndexOrThrow(DatesTable.DatesEntry._ID));
            String itemDateTime = cursor.getString(cursor.getColumnIndexOrThrow(DatesTable.DatesEntry.COLUMN_NAME_LOGDATETIME));
            itemIds.add(itemId);
            Log.d("Testing", "ID: " + itemId + " DATETIME: " + itemDateTime);
            sb.append(itemId);
            sb.append("T");
            sb.append(itemDateTime);
            sb.append(";");
            lastIdSended = itemId;
        }
        cursor.close();

        SharedPreferences.Editor editor = sharedPrefs.edit();
        editor.putLong("lastidsended", lastIdSended);
        editor.commit();

        GetRequest gr = new GetRequest();
        gr.setActivity(this);
        gr.execute("http://gisak.vsb.cz/patrac/testtracker.php?" + sb.toString());
        //gr.execute("http://gisak.vsb.cz/patrac/testtracker.php?A=A");
    }

    @Override
    public IBinder onBind(Intent arg0) {
        // TODO Auto-generated method stub
        Log.d("Testing", "Service onBind");
        return null;
    }

    @Override
    public void onDestroy() {
        // TODO Auto-generated method stub
        Log.d("Testing", "Service onDestroy");
        super.onDestroy();
    }


    @Override
    public void processResponse(String result) {
        Log.d("Testing", "Service processResponse " + result);
        if (result != null) {
            Context context = this;
            SharedPreferences sharedPrefs = PreferenceManager.getDefaultSharedPreferences(context);
            SharedPreferences.Editor editor = sharedPrefs.edit();
            long lastIdSended = sharedPrefs.getLong("lastidsended", 16);
            editor.putLong("lastid", lastIdSended);
            editor.commit();
        }
        this.stopSelf();
    }
}